package com.kingdee.eas.custom.performancenew.service;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.sql.ParserException;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.performancenew.*;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseColumnInfo;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseImportService;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseRowInfo;
import com.kingdee.shr.base.syssetting.app.io.fileImport.ImportException;
import com.kingdee.shr.ml.util.SHRServerResource;
import com.kingdee.util.StringUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 * @author qingwu
 * @date 2024/4/19
 * @apiNote ڼȣרԱ룩Ա˵ȼ
 */
public class ExamineGradeImportPFRService extends BaseImportService {
    //@Override
    //protected String getPKSelectString(BaseRowInfo row) {
    //    String pkSelectString = super.getPKSelectString(row);
    //    String parentId = getCustomParam("parentId");
    //    if (StringUtils.isEmpty(parentId)) {
    //        throw new RuntimeException("ЧڱIDΪգ");
    //    }
    //    return pkSelectString + " and parent.id ='" + parentId + "'";
    //}


    //@Override
    //public void completeGenerateExcel(Map<String, BaseColumnInfo> columnInfoMap, XSSFWorkbook wb, XSSFSheet sheet) {
    //    String parentId = getCustomParam("parentId");
    //    if (StringUtils.isEmpty(parentId)) {
    //        throw new RuntimeException("ЧڱIDΪգ");
    //    }
    //    super.completeGenerateExcel(columnInfoMap, wb, sheet);
    //}
    @Override
    public void completeGenerateExcel(Map<String, BaseColumnInfo> columnInfoMap, XSSFWorkbook wb, XSSFSheet sheet) {
        Context ctx = getContext();
        String parentId = getCustomParam("parentId");
        if (StringUtils.isEmpty(parentId)) {
            throw new RuntimeException("ЧڱIDΪգ");
        }
        int beginRow = 4;
        try {
            //ǰ¼Աid
            String currentPersonId = ContextUtil.getCurrentUserInfo(ctx).getPerson().getId().toString();
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("index");
            sic.add("auditor.name");
            sic.add("adminOrg.name");
            sic.add("adminOrg.id");
            FilterInfo filterInfo = new FilterInfo();
            FilterItemCollection filterItems = filterInfo.getFilterItems();
            filterItems.add(new FilterItemInfo("parent.id", parentId));
            filterItems.add(new FilterItemInfo("orderStatuc", "2", CompareType.NOTEQUALS));
            filterItems.add(new FilterItemInfo("scorer.id", currentPersonId));
            SorterItemCollection sorterItemCollection = new SorterItemCollection("adminOrg.id,index");
            EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, sorterItemCollection);
            IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);

            ExamineGradePersonEntryCollection entryCollection = iExamineGradePersonEntry.getExamineGradePersonEntryCollection(entityViewInfo);
            Map<Integer, String> columnIndexMap = getColumnIndexFn(columnInfoMap);
            int fillColumnCount = columnInfoMap.size();
            for (int i = 0; i < entryCollection.size(); i++) {
                XSSFRow xSSFRow = sheet.createRow(i + beginRow);
                ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entryCollection.get(i);
                for (int j = 0; j < fillColumnCount; j++) {
                    String value = null;
                    Cell createCell = xSSFRow.createCell(j);
                    String columnName = columnIndexMap.get(Integer.valueOf(j));
                    Object obj = examineGradePersonEntryInfo.get(columnName);
                    if (obj != null) {
                        if (obj instanceof CoreBaseInfo) {
                            CoreBaseInfo coreBaseInfo = (CoreBaseInfo) examineGradePersonEntryInfo.get(columnName);
                            //value = coreBaseInfo.get("number") + "##" + coreBaseInfo.get("name");
                            value = (String) coreBaseInfo.get("name");
                        } else if (obj instanceof BigDecimal) {
                            BigDecimal bigDecimal = (BigDecimal) obj;
                            value = bigDecimal.setScale(2).toPlainString();
                        } else {
                            value = obj.toString();
                        }
                    }
                    createCell.setCellValue(value);
                }
            }
        } catch (BOSException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        } catch (ParserException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }

    @Override
    protected void submitData(CoreBaseInfo coreBaseInfo) throws ImportException {
        SelectorItemCollection updateSic = new SelectorItemCollection();
        updateSic.add("index");
        try {
            IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(getContext());
            iExamineGradePersonEntry.updatePartial(coreBaseInfo, updateSic);
        } catch (EASBizException var4) {
            ImportException importException = new ImportException(var4.getMessage(getContext().getLocale()), (Throwable) var4);
            throw importException;
        } catch (BOSException var5) {
            ImportException importException = new ImportException(SHRServerResource.getString("com.kingdee.shr.base.syssetting.CommonserviceResource", "save_fails_bos", getContext()), (Throwable) var5);
            throw importException;
        } catch (Exception var6) {
            ImportException importException = new ImportException(SHRServerResource.getString("com.kingdee.shr.base.syssetting.CommonserviceResource", "save_submit_fails", getContext()), var6);
            throw importException;
        }
    }

    protected Map<Integer, String> getColumnIndexFn(Map<String, BaseColumnInfo> columnInfoMap) {
        Map<Integer, String> columnIndexMap = new HashMap<>();
        Iterator<String> keys = columnInfoMap.keySet().iterator();
        int var4 = 0;
        while (keys.hasNext()) {
            String key = keys.next();
            columnIndexMap.put(Integer.valueOf(var4++), key);
        }
        return columnIndexMap;
    }

    @Override
    protected String getPKSelectString(BaseRowInfo row) {
        String parentId = getCustomParam("parentId");
        List<BaseColumnInfo> keyColumnList = row.getKeyColumnInfo();
        for (int i = 0; i < keyColumnList.size(); i++) {
            BaseColumnInfo keyColumn = keyColumnList.get(i);
            keyColumn.setCustomField(false);
        }
        return super.getPKSelectString(row) + " and parent.id ='" + parentId + "'";
    }
}
